; 
    include \masm32\include\masm32rt.inc
    .686
    include timers.asm

    bin2dword PROTO :DWORD
    b2dw      PROTO :DWORD
    bin2dw    PROTO :DWORD

; 
    .data
      b00   db "00000000000000000000000000000000",0
      b01   db "00000000000000000000000000000001",0
      b02   db "00000000000000000000000000000010",0
      b03   db "00000000000000000000000000000111",0
      b04   db "00000000000110100100000000000010",0
      b05   db "10000000000000000000000000000000",0
      b06   db "11000000000000000000000000000000",0
      b07   db "01000000000000000000000000000001",0
      b08   db "01010101010101010101010101010101",0
      b09   db "10101010101010101010101010101010",0
      b10   db "11111111111111111111111111111111",0
      b11   db "0000000000000000000000000100",0
      b12   db "00000000000000000000000001",0
      b13   db "1010101010101010101010",0
      b14   db "1010101010101010101",0
      b15   db "1111111111111111",0
      b16   db "0000000000111",0
      b17   db "01100110",0
      b18   db "100000",0
      b19   db "10001",0
      b20   db "100",0
      b21   db "0",0
      b22   db "1",0
    .code
; 
start:
; 
    FOR arg,<b00,b01,b02,b03,b04,b05,b06,b07,b08,b09,b10,\
            b11,b12,b13,b14,b15,b16,b17,b18,b19,b20,b21,b22>
      invoke crt_strtoul,ADDR arg,NULL,2
      print ustr$(eax),13,10
      invoke bin2dword,ADDR arg
      print ustr$(eax),13,10
      invoke b2dw,ADDR arg
      print ustr$(eax),13,10
      invoke bin2dw,ADDR arg
      print ustr$(eax),13,10,13,10
    ENDM
    
    LOOP_COUNT EQU 10000000

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke bin2dword,ADDR b08
    counter_end
    print ustr$(eax)
    print " cycles, bin2dword 32-bit input",13,10

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke b2dw,ADDR b08
    counter_end
    print ustr$(eax)
    print " cycles, b2dw 32-bit input",13,10

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke bin2dw,ADDR b08
    counter_end
    print ustr$(eax)
    print " cycles, bin2dw 32-bit input",13,10

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke bin2dword,ADDR b17
    counter_end
    print ustr$(eax)
    print " cycles, bin2dword 8-bit input",13,10

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke b2dw,ADDR b17
    counter_end
    print ustr$(eax)
    print " cycles, b2dw 8-bit input",13,10

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke bin2dw,ADDR b17
    counter_end
    print ustr$(eax)
    print " cycles, bin2dw 8-bit input",13,10

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke bin2byte_ex,ADDR b17
    counter_end
    print ustr$(eax)
    print " cycles, bin2byte_ex 8-bit input",13,10

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke bin2dword,ADDR b22
    counter_end
    print ustr$(eax)
    print " cycles, bin2dword 1-bit input",13,10

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke b2dw,ADDR b22
    counter_end
    print ustr$(eax)
    print " cycles, b2dw 1-bit input",13,10

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke bin2dw,ADDR b22
    counter_end
    print ustr$(eax)
    print " cycles, bin2dw 1-bit input",13,10

    inkey "Press any key to exit..."
    exit

; 
; Tried a byte table version, was slower and larger.
; Tried a cmov version, was slower (and less compatible).
; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 4

bin2dword proc pszbinstr:DWORD

    push esi
    mov esi, [esp+8]
    mov ecx, 1 SHL 31             ; load value for bit 31
    xor edx, edx
    xor eax, eax

  align 4
  digitLoop:

    cmp BYTE PTR[esi+edx], '1'
    jne @F
    add eax, ecx                  ; add current bit value to total
  @@:
    add edx, 1
    shr ecx, 1                    ; adjust to bit value for next bit
    cmp BYTE PTR[esi+edx-1], 0
    jne digitLoop

    mov ecx, 33                   ; adjust result for < 32 digits
    sub ecx, edx
    shr eax, cl

    pop esi
    ret  4

bin2dword endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align  16

db     8Dh,0A4h,24h,0,0,0,0,90h

b2dw   proc   lpszbinstr:dword
       mov    edx, [esp+4]
       mov    ecx, 1 SHL 31         ; load value for bit 31
       xor    eax, eax
       cmp    byte ptr [edx], '0'
       lea    edx, [edx+1]
       je     @f
       lea    eax, [eax+ecx]        ; add current bit value to total
       jc     @1
@@:
       shr    ecx, 1                ; adjust to bit value for next bit
       cmp    byte ptr [edx], '0'
       lea    edx, [edx+1]
       je     @b
       lea    eax, [eax+ecx]        ; add current bit value to total
       ja     @b
@1:
       sub    edx, [esp+4]
       mov    ecx, 33               ; adjust result for < 32 digits
       sub    ecx, edx
       shr    eax, cl
       ret    4

b2dw   endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align  16

bin2dw   proc   lpszbinstr:dword

    mov edx, [esp+4]
    mov cl, '0'
    xor eax, eax
@@:
i = 0
REPEAT 1 ;unroll block
    cmp cl, [edx+i]
    ja @F
    rcl eax, 1
    i = i + 1
ENDM
    add edx, i
    jmp @B
@@:
    ret    4

bin2dw   endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 
end start
